/* * * * * * * * * * * * * * * * * * * * * * */
/*      SETKISS - Set TNC to KISS mode       */
/*       (c) OE3GMW & OE1HHC 01.05.93        */
/*                                           */
/*        Support Programm fr TFPCR         */
/* * * * * * * * * * * * * * * * * * * * * * */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <conio.h>


/*                                            lokale Funktionsprototypen  */
/**************************************************************************/
static   unsigned  pascal is_loaded(void);
static   unsigned  pascal kiss_if(unsigned, char);
static   void      pascal putstrkiss_if (char *);
static   void      pascal set_kiss(char *);


/*                                                      globale Variable  */
/**************************************************************************/
unsigned tfpcr_int;                        /* von TFPCR benutzter Vektor  */


/*                                                         here we start  */
/**************************************************************************/
void main(int argc, char **argv)
{
  directvideo = 0;
  if (!(tfpcr_int = is_loaded())) {
    cprintf("    Fatal error. Hostmode interface not found!\r\n\n"\
            "    SETKISS cannot be used as a standalone application program.\r\n"\
            "    Load hostmode interface driver TFPCR 3.xx first!\r\n\7");
    exit(1);
  }

  cprintf(" ͻ\r\n" \
          "     SetKiss       Version 1.10    \r\n" \
          "       \r\n" \
          "  (c) OE3GMW & OE1HHC  %s \r\n" \
          " ͼ\r\n\n", __DATE__);

  if (argc == 2)                        /* Auswertung der Kommandozeile   */
    set_kiss(argv[1]);
  else
    set_kiss(NULL);

  exit(0);
}



/*                  Interrupttabelle nach installiertem Code durchsuchen  */
/**************************************************************************/
static unsigned pascal is_loaded(void)
{
  unsigned  i = 0x100;

  while (i-- > 0x2f) {
    if (!_fmemcmp(((char far *)getvect(i) + 3), "N5NX", 4))
      return(i);
  }
  return(0);
}


/*                                      String an Kissinterface ausgeben  */
/**************************************************************************/
static void pascal putstrkiss_if (char *s)
{
  while (*s)
    kiss_if(3, *s++);
  kiss_if(3, '\r');
}


/*                             KISS interface call fr Funktionen 0 .. 3  */
/**************************************************************************/
static unsigned pascal kiss_if(unsigned cmd, char ch)
{
  union   REGS    cpu;

  cpu.h.ah = cmd;
  cpu.h.al = ch;
  int86(tfpcr_int, &cpu, &cpu);
  return(cpu.h.al);
}


/*                                        Datei an KISS interface senden  */
/**************************************************************************/
static void pascal set_kiss(char *fn)
{
  FILE  *fd;
  char   buf[85];
  char  *p;

  if (fn == NULL)
    fn = "AUTOKISS.CFG";
  else
    strupr(fn);

  if ((fd = fopen(fn, "rt")) == NULL) {
    cprintf("%s - File not found!\r\n\7", fn);
    exit(1);
  }

  cprintf("*** sending file %s to TNC ***\r\n\n", fn);

  buf[0] = '\x1B';
  buf[1] = '@';
  buf[2] = 'K';
  while (fgets(&buf[3], 80, fd)) {
    p = buf + strlen(buf);
    if (*--p == '\n')
      *p = '\0';
    putstrkiss_if(buf);
    while (kiss_if(1, 0))                 /* Zeichen vom Host Interface   */
      putch(kiss_if(2, 0));               /* auf den Bildschirm ausgeben  */
  }

  fclose(fd);
  cprintf("\r\n***  TNC should be in KISS mode now  ***\r\n");
}

/* Ende von SETKISS */
