/* * * * * * * * * * * * * * * * * * * * * */
/*           TFPCT - MicroTerm             */
/*      (c) OE3GMW & OE1HHC 01.05.93       */
/*                                         */
/*   Minimal Terminal Programm fr TFPCR   */
/* * * * * * * * * * * * * * * * * * * * * */

#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <conio.h>


/*                                            lokale Funktionsprototypen  */
/**************************************************************************/
static   unsigned  pascal is_loaded(void);
static   unsigned  pascal kiss_if(unsigned, char);
static   void      pascal termloop(void);


/*                                                      globale Variable  */
/**************************************************************************/
unsigned tfpcr_int;                        /* von TFPCR benutzter Vektor  */


/*                                                         here we start  */
/**************************************************************************/
void main(void)
{
  directvideo = 0;
  if (!(tfpcr_int = is_loaded())) {
    cputs("    Fatal error. Hostmode interface not found!\r\n\n"\
          "    TFPCT cannot be used as a standalone application program.\r\n"\
          "    Load hostmode interface driver TFPCR 3.xx first!\r\n\7");
    exit(1);
  }

  window(1, 25, 80, 25);
  textbackground(WHITE);
  textcolor(BLACK);
  clrscr();
  _wscroll = 0;
  cputs(" TFPCT - MicroTerm v 2.10           (c) OE3GMW & OE1HHC"\
        "           Alt-X to exit ");
  window(1, 1, 80, 24);
  textbackground(BLACK);
  textcolor(WHITE);
  lowvideo();
  clrscr();
  _wscroll = 1;

  termloop();

  normvideo();
  window(1, 1, 80, 25);
  clrscr();
  exit(0);
}


/*                  Interrupttabelle nach installiertem Code durchsuchen  */
/**************************************************************************/
static unsigned pascal is_loaded(void)
{
  unsigned  i = 0x100;

  while (i-- > 0x2f) {
    if (!_fmemcmp(((char far *)getvect(i) + 3), "N5NX", 4))
      return(i);
  }
  return(0);
}


/*                                                         ein MikroTerm  */
/**************************************************************************/
static void pascal termloop(void)
{
  unsigned  och = 1, ch;

  for (;;) {
    while (kiss_if(1, 0))
      putch(kiss_if(2, 0));
    if (kbhit()) {
      ch = getch();
      if ((!och) && (ch == 45))                         /* Alt - X : Exit */
        break;
      else
        if (ch)
          kiss_if(3, ch);
      och = ch;
    }
  }
}


/*                             KISS interface call fr Funktionen 0 .. 3  */
/**************************************************************************/
static unsigned pascal kiss_if(unsigned cmd, char ch)
{
  union   REGS    cpu;

  cpu.h.ah = cmd;
  cpu.h.al = ch;
  int86(tfpcr_int, &cpu, &cpu);
  return(cpu.h.al);
}

/* Ende von TFPCT */
