/* * * * * * * * * * * * * * * * * * * * * */
/*       TRSTAT - TfpcrRemoteSTATus        */
/*      (c) OE3GMW & OE1HHC 01.05.93       */
/*                                         */
/*    Remote Support Programm fr TFPCR    */
/*                                         */
/* * * * * * * * * * * * * * * * * * * * * */

#include <ctype.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/*                                            lokale Funktionsprototypen  */
/**************************************************************************/
static  void        pascal banner(void);
static  void far   *pascal get_farp(unsigned);
static  unsigned    pascal is_loaded(void);
static  void        pascal show_debug(unsigned far *);
static  void        pascal show_xdebug(unsigned char far *);


/*                                                      globale Variable  */
/**************************************************************************/
static unsigned tfpcr_int;                 /* von TFPCR benutzter Vektor  */


/*                                                         here we start  */
/**************************************************************************/
void main(void)
{
  struct time   t;
  struct date   d;
  unsigned far *p;
  char near *c;
  int i;

  if (!(tfpcr_int = is_loaded())) {
    printf("    Fatal error. Hostmode interface not found!\r\n\n"\
           "    TRSTAT cannot be used as a standalone application program.\r\n"\
           "    Load hostmode interface driver TFPCR 3.xx first!\r\n\7");
    exit(1);
  }

  c = _argv[1];
  if ((*c == '/') || (*c == '-'))
    c++;
  else
    c = "D";

  switch (toupper(*c)) {
    case '?':
    case 'H': printf( \
      "Usage:\n"\
      "    TRSTAT [[-?][-H][-R][-X]]\n\n"\
      " ?  or  H  this text.\n"\
      " R  reset TFPCR's internal debug/status counters.\n"\
      " X  show extended status information,\n"\
      "    If there is no commandline parameter specified, the program\n"\
      "    will show TFPCR's internal debug/status information.\n\n");
              exit(0);

    case 'D': banner();
              show_debug(get_farp(0x700));
              break;

    case 'R': banner();                 /* Statusinformationen rcksetzen */
              p = get_farp(0x700);
              for (i = 0; i < 5; i++)
                *p++ = 0;
              printf("Status counters reset.\n");
              break;

    case 'X': banner();
              show_xdebug(get_farp(0x500));
              break;

    default:  printf("Illegal commandline option!  Use TRSTAT -H for Help.\n");
              exit(1);
  }
  gettime(&t);
  getdate(&d);
  printf("\nTRSTAT-timestamp: %2d.%02d.%02d - %2d:%02d:%02d\n\n", \
         d.da_day, d.da_mon, d.da_year, t.ti_hour, t.ti_min, t.ti_sec);
}


/*                                                  Kopfmeldung ausgeben  */
/**************************************************************************/
static void pascal banner(void)
{
  printf("\n  TRSTAT - TfpcrRemoteSTATus  v 1.10"
         "\n  (c) OE3GMW & OE1HHC    %s"
         "\n\n",
         __DATE__);
}


/*                                       Show extended debug information  */
/**************************************************************************/
static void pascal show_xdebug(unsigned char far *p)
{
  char          i, j;
  unsigned char line[] = \
    "Offset  0  1  2  3  4  5  6  7    8  9  A  B  C  D  E  F" \
    "   0123456789ABCDEF";

  printf("System variables located at hex %04X:%04X. Dump:\n\n", \
          FP_SEG(p), FP_OFF(p));
  printf("%s\n", line);
  
  for (i = 0; i < 8; i++) {           /* 8 Zeilen zu je 16 Byte "dumpen"  */
    sprintf(line, "+%02Xh:  ", i << 4);
    for (j = 0; j < 16; j++) {        /* 16 Byte 2-stelliger Hexdump      */
      sprintf(line + strlen(line), "%02X ", *(p + j));
      if (j == 7)
        strcat(line, "  ");           /* optische Trennung nach 8 Byte    */
    }
    strcat(line, "  ");
    
    for (j = 0; j < 16; j++, p++)     /* 16 Byte ASCII-Dump               */
      sprintf(line + strlen(line), "%c", isprint(*p) ? *p : '.');
    
    j = strlen(line) - 1;             /* rechtsbndige Spaces lschen     */
    while (line[j] == ' ')
      line[j--] = '\0';
    
    printf("%s\n", line);             /* ganze Zeile ausgeben             */
  }
  return;
}


/*                                                Show debug information  */
/**************************************************************************/
static void pascal show_debug(unsigned far *p)
{
  int i;
  char *txt[] = {"Maximum load of RS-232 input buffer ... %u\n", \
                 "Maximum load of RS-232 out buffer ..... %u\n", \
                 "Maximum load of Host output buffer .... %u\n", \
                 "Number of RS-232 communication errors . %u\n", \
                 "Number of unexpected comm. interrupts . %u\n" };

  printf("Debugging counters located at hex ..... %04X:%04X\n", \
         FP_SEG(p), FP_OFF(p));
  for (i = 0; i < 5; i++)
    printf(txt[i], *p++);
  return;
}

/*                  Interrupttabelle nach installiertem Code durchsuchen  */
/**************************************************************************/
static unsigned pascal is_loaded(void)
{
  unsigned  i = 0x100;

  while (i-- > 0x2f) {
    if (!_fmemcmp(((char far *)getvect(i) + 3), "N5NX", 4))
      return(i);
  }
  return(0);
}


/*                                                      Far Zeiger holen  */
/**************************************************************************/
static void far *pascal get_farp(unsigned fnc)
{
  struct  REGPACK cpu;

  cpu.r_ax = fnc;
  intr(tfpcr_int, &cpu);
  if (cpu.r_ax) {
    printf("\nUnprecedented response of hostmode interface!\n\7");
    exit(1);
  }
  return(MK_FP(cpu.r_es, cpu.r_bx));
}

/* Ende von TRSTAT */
